unit polygrafu1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    btBerechne: TButton;
    btGrafik: TButton;
    FloatSpinEdit1: TFloatSpinEdit;
    FloatSpinEdit2: TFloatSpinEdit;
    FloatSpinEdit3: TFloatSpinEdit;
    FloatSpinEdit4: TFloatSpinEdit;
    FloatSpinEdit5: TFloatSpinEdit;
    FloatSpinEdit6: TFloatSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ListBox1: TListBox;
    SpinEdit1: TSpinEdit;
    procedure btBerechneClick(Sender: TObject);
    procedure btGrafikClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }
uses polygrafu2;

type TFeld = record
               x,y   :single;
             end;
var blGrafik      :boolean;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption:='a3';
  Label2.Caption:='a2';
  Label3.Caption:='a1';
  Label4.Caption:='a0';
  Label5.Caption:='xmin';
  Label6.Caption:='xmax';
  Label7.Caption:='Auflös.';
  FloatSpinEdit1.Value:=0;
  FloatSpinEdit2.Value:=1;
  FloatSpinEdit3.Value:=0;
  FloatSpinEdit4.Value:=0;
  FloatSpinEdit5.Value:=-3;
  FloatSpinEdit6.Value:=3;
  SpinEdit1.Increment:=10;
  SpinEdit1.MaxValue:=1000;
  SpinEdit1.MinValue:=1;
  SpinEdit1.Value:=100;
  blGrafik:=false;
  btGrafik.Caption:='Grafik an';
end;      {FormCreate}

procedure TForm1.btBerechneClick(Sender: TObject);
var a,i                                  :integer;
    sw,a3,a2,a1,a0,x,y,xmin,xmax         :single;
    feld                                 :array of TFeld;
begin
  Screen.Cursor:=crHourGlass;
  ListBox1.Clear;
  Form2.Chart1LineSeries1.Clear;
  a3:=FloatSpinEdit1.Value;
  a2:=FloatSpinEdit2.Value;
  a1:=FloatSpinEdit3.Value;
  a0:=FloatSpinEdit4.Value;
  xmin:=FloatSpinEdit5.Value;
  xmax:=FloatSpinEdit6.Value;
  a:=SpinEdit1.Value;
  sw:=(xmax-xmin)/a;
  x:=xmin;
  SetLength(feld,a+1);
  i:=0;
  while x<xmax+sw do begin
    y:=a3*x*x*x+a2*x*x+a1*x+a0;
    feld[i].x:=x;
    feld[i].y:=y;
    x:=x+sw;
    inc(i);
  end;  {while}
  for i:=Low(feld) to High(feld) do begin ListBox1.Items.Add
   (FloatToStrF(feld[i].x,ffFixed,4,2)+'  '+FloatToStrF(feld[i].y,ffFixed,4,2));
   Form2.Chart1LineSeries1.AddXY(feld[i].x,feld[i].y);

  end;  {for}
//  Form2.Chart1.AddSeries(LS1);


  SetLength(feld,0);
  Screen.Cursor:=crDefault;
end;      {btBerechne}

procedure TForm1.btGrafikClick(Sender: TObject);
begin
  blGrafik:=not blGrafik;
  if blGrafik then begin
    btGrafik.Caption:='Grafik aus';
    Form2.Visible:=true;
  end else begin
    btGrafik.Caption:='Grafik an';
    Form2.Visible:=false;
    Form2.Chart1.Refresh;
  end;
end;      {btGrafikClick}

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Form2.Close;
end;      {FormClose}

end.

